import pinhook.plugin as p
import re
import urllib.request as http
import json
import operator
import shelve
from random import choice, randint

"""
A plugin for storing/retrieving karma
"""


def count(msg, points):
    s = shelve.open('karma.db', writeback=True)
    clean = msg.strip('+').strip()
    key = str(clean + msg.channel + msg.bot.servers[0].host)
    if points:
        if key in s:
            s[key] = int(s[key]) + int(points)
        else:
            s[key] = int(points)
    output = s[key]
    s.sync()
    s.close()
    return output

def inc_count(msg):
    current = count(msg) + 1
    count(msg, current)
    return current

@p.listener('karmalistener')
def karmalistener(msg):
    if msg.text.endswith("++"):
        clean = msg.strip('+').strip()
        karma_count = inc_count(msg)
        return p.message("{} now has {} karma".format(clean, karma_count)


@p.register('!karma', 'Show Karma for User')
def karma(msg):
    if msg.arg:
        clean = msg.arg.strip('+').strip()
        karma_count = count(clean)
        return p.message("{} has {} karma".format(msg.arg, karma_count))
    else:
        return p.message("Usage: !karma <phrase> - returns the amount of karma stored for a particular word/phrase")

